> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Submit an aggregate query job

POST https://rest.test.zuora.com/v1/batch-query
Content-Type: application/json

Submits an AQuA job that contains an aggregated list of ZOQL and Export ZOQL queries.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/aqua/aggregate-queries/post-batch-query-job

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a SubmitBatchQueryRequest.

- `dateTimeUtc` (boolean, optional) — When using WSDL 69 and later you can ensure that the exported output of dateTime records are rendered according to ISO-8601 generic UTC form by setting `dateTimeUtc` to `true`. When `dateTimeUtc` is set to `true`, exports of dateTime data types will be rendered in the following generic format: `YYYY-MM-DDThh:mm:ss-hhmm` or `YYYY-MM-DDThh:mm:ss+hhmm`. **Note**: Regardless of what batchType query is used (`zoql` or `zoqlexport`), the query response output for datetime data types can be standardized by setting dateTimeUtc to `true`. When `true`, the results will display datetime types with the format: YYYY-MM-DDThh:mm:ss+/-hhmm.
- `format` (enum, optional) — The format of the query. The default value is `csv`.
  - Allowed values: `csv`, `zip`, `gzip`
- `incrementalTime` (string, optional) — Allows you to override the time from which a Stateful AQuA job incrementally retrieves records that have been created or modified, using the `incrementalTime` parameter. For example, if you set `incrementalTime` = `2015-01-21 10:30:01`, AQuA will retrieve records that have created or modified beginning at 10:30:01. If this parameter is not set, AQuA continues to use the Start Time of the last AQuA session to retrieve records incrementally. The time zone of `incrementalTime` depends on which Zuora data center you use. For US Data Center customers, the time zone of `incrementalTime` is Pacific Time. For EU Data Center customers, the time zone of `incrementalTime` is UTC. If the time zone of your system is different from the time zone of `incrementalTime`, you will need to convert to the appropriate time zone before setting `incrementalTime`. **Note**: This field can only be used in Stateful AQuA mode.
- `name` (string, optional) — The name of the job. 32 character limit.
- `notifyUrl` (string, optional) — If URL is provided, the AQuA job will call this `notifyUrl` once the job has completed. The value of `notifyUrl` needs to have `${JOBID}` and `${STATUS}` placeholders. These placeholders will be replaced by the actual job ID and status when returned in the response. Status will be `Completed` after the AQuA job is done. If you submit an AQuA query with `notifyUrl` specified, the value of `notifyUrl` will be ignored if your organization has already configured a callout notification through the Zuora user interface.
- `nullReplacement` (string, optional) — The string used to represent null values in the query results. If you do not set this parameter, null values are represented by the empty string in the query results.
- `offset` (integer, optional, default: 0) — This field specifies the time offset for AQuA queries in stateful mode. It is an integer in the range 0 to 3,600 seconds. For example, if you set this field to 600 seconds and you post a query in stateful mode at 2:00 AM, it will query against data created or updated between the completion time of the previous query and 1:50 AM. The value of this field will override the value you configured in **Settings** > **Administration** > **AQuA API Stateful Mode Time Offset**.
- `partner` (string, optional) — The partner field indicates the unique ID of a data integration partner. The dropdown list of this field displays partner IDs for the past thirty days. It must be used together with "project" field to uniquely identify a data integration target. For example, if a continuous AQuA session is to retrieve data incrementally for a Salesforce.com Org 00170000011K3Ub, you can use partner as "Salesforce", and "project" as "00170000011K3Ub." This field is required only if you are using AQuA in stateful mode. Otherwise, if you are using AQuA in stateless mode, partner field can be null. **Note**: Zuora highly recommends you use the stateless mode instead of the stateful mode to extract bulk data. See Bulk data extraction from Zuora using AQuA for best practices. **Note**: Submit a request at Zuora Global Support to obtain a partner ID.
- `project` (string, optional) — The project field contains the unique ID of a data integration project for a particular partner. The dropdown list of this field displays project IDs for the past thirty days. This field must be used together with partner field to uniquely identify a data integration target. This field is required only if you are using AQuA in stateful mode. Otherwise, if you are using AQuA in stateless mode, partner field can be null.
- `queries` (list of BatchQuery, optional) — A JSON array object that contains a list of batch objects.
- `sourceData` (enum, optional) — Specify the source this aggregate query runs against: * `LIVE` represents the live transactional databases at Zuora (Data Query Live). If this field is not specified, the default value `LIVE` will be used.
  - Allowed values: `LIVE`
- `useQueryLabels` (boolean, optional) — When this optional flag is set to `true` the request will use object and field API names for the CSV header output instead of the field labels. Data integration projects should set `useQueryLabels` to `true` so that API names remain the same. By default `useQueryLabels` is `false`, so that output CSV headers display the more user-friendly object and field labels.
- `version` (float, optional) — The API version you want to use. The supported versions are as follows: * `1.1`. It supports both modes * `1.0`. Default. It supports stateless modes only. See Stateless and stateful modes for more information.

## Response

### 200

OK

- `batches` (list of BatchesQueries, optional) — A JSON array object that contains a list of batch objects.
- `encrypted` (enum, optional) — If enabled, you must supply the formatting (zip or unzip) first and decrypt it to get the actual contents.
  - Allowed values: `pgp`, `none`
- `format` (enum, optional) — The format of the query. The default value is `csv`.
  - Allowed values: `csv`, `zip`, `gzip`
- `id` (string, optional) — The job ID created for the AQuA API request. The job ID can be used for querying for the query status. The ID exists only if the JSON request can be parsed and validated successfully. Otherwise, the job ID is null.
- `incrementalTime` (string, optional) — Allows you to override the time from which a Stateful AQuA job incrementally retrieves records that have been created or modified, using the `incrementalTime` parameter. For example, if you set `incrementalTime` = `2015-01-21 10:30:01`, AQuA will retrieve records that have created or modified beginning at 10:30:01. If this parameter is not set, AQuA continues to use the Start Time of the last AQuA session to retrieve records incrementally. The time zone of `incrementalTime` depends on which Zuora data center you use. For US Data Center customers, the time zone of `incrementalTime` is Pacific Time. For EU Data Center customers, the time zone of `incrementalTime` is UTC. If the time zone of your system is different from the time zone of `incrementalTime`, you will need to convert to the appropriate time zone before setting `incrementalTime`. **Note**: This field can only be used in Stateful AQuA mode.
- `name` (string, optional) — The name of the job. 32 character limit.
- `notifyUrl` (string, optional) — If URL is provided, the AQuA job will call this `notifyUrl` once the job has completed. The value of `notifyUrl` needs to have `${JOBID}` and `${STATUS}` placeholders. These placeholders will be replaced by the actual job ID and status when returned in the response. Status will be `Completed` after the AQuA job is done. If you submit an AQuA query with `notifyUrl` specified, the value of `notifyUrl` will be ignored if your organization has already configured a callout notification through the Zuora user interface.
- `offset` (integer, optional, default: 0) — This field specifies the time offset for AQuA queries in stateful mode. It is an integer in the range 0 to 3,600 seconds. For example, if you set this field to 600 seconds and you post a query in stateful mode at 2:00 AM, it will query against data created or updated between the completion time of the previous query and 1:50 AM. The value of this field will override the value you configured in **Settings** > **Administration** > **AQuA API Stateful Mode Time Offset**.
- `partner` (string, optional) — The partner field indicates the unique ID of a data integration partner. The dropdown list of this field displays partner IDs for the past thirty days. It must be used together with "project" field to uniquely identify a data integration target. For example, if a continuous AQuA session is to retrieve data incrementally for a Salesforce.com Org 00170000011K3Ub, you can use partner as "Salesforce", and "project" as "00170000011K3Ub." This field is required only if you are using AQuA in stateful mode. Otherwise, if you are using AQuA in stateless mode, partner field can be null. **Note**: Zuora highly recommends you use the stateless mode instead of the stateful mode to extract bulk data. See Bulk data extraction from Zuora using AQuA for best practices. **Note**: Submit a request at Zuora Global Support to obtain a partner ID.
- `project` (string, optional) — The project field contains the unique ID of a data integration project for a particular partner. The dropdown list of this field displays project IDs for the past thirty days. This field must be used together with partner field to uniquely identify a data integration target. This field is required only if you are using AQuA in stateful mode. Otherwise, if you are using AQuA in stateless mode, partner field can be null.
- `sourceData` (string, optional) — Indicates the source this aggregate query runs against: * `LIVE` represents the live transactional databases at Zuora (Data Query Live).
- `status` (enum, optional) — The status of the AQuA job: - submitted: The AQuA job was submitted to the query executor for processing. - executing: The AQuA job is being processed. - completed: The AQuA job was successfully executed. - error: The AQuA job was not processed because of validation errors. - aborted: The AQuA job execution failed because one or more queries of this job failed. - cancelled: The AQuA job was cancelled.
  - Allowed values: `submitted`, `executing`, `completed`, `error`, `aborted`, `cancelled`
- `useLastCompletedJobQueries` (boolean, optional) — If this flag is set to `true`, then all the previous queries are merged with existing queries. If the flag is set to `false`, then the previous queries are ignored, and only the new query is executed.
- `version` (float, optional) — The API version you want to use. The supported versions are as follows: * `1.1`. It supports both modes * `1.0`. Default. It supports stateless modes only. See Stateless and stateful modes for more information.

## Types

### BatchQuery

- `apiVersion` (string, optional) — The API version for the query. If an API version is not specified, the latest version is used by default. Using the latest WSDL version is most useful for reporting use cases. For integration purposes, specify the WSDL version to ensure consistent query behavior, that is, what is supported and included in the response returned by the API. **Note**: As of API version 69 and later, Zuora changed the format of certain fields. See Date Field Changes in the SOAP API for more information and a list of affected fields.
- `convertToCurrencies` (string, optional) — The currencies that you want to convert transaction amounts into. You can specify any number of currencies. Specify the currencies using their ISO currency codes and separate each currency with a comma, for example, "EUR,GBP,JPY". See Convert Transaction Amounts Into Any Currency for more information and examples. To use this field, you must have Foreign Currency Conversion enabled and you must be using API version 78 or later.
- `deleted` (list of BatchQueryDeletedItems, optional) — This field indicates that the AQuA incremental load will retrieve deleted records. If you want to export deleted data, this field is required. **Note**: AQuA API is subject to Zuora Data Retention Policy. The retention period of deleted data is 30 days. You can only retrieve deleted data for 30 days through AQuA.
- `name` (string, optional) — The query name that can uniquely identify the query in this API request.
- `query` (string, optional) — A valid ZOQL query or Export ZOQL query statement.
- `type` (enum, optional) — The query type.
  - Allowed values: `zoql`, `zoqlexport`

### BatchesQueries

- `apiVersion` (string, optional) — The API version for the query. If an API version is not specified, the latest version is used by default. Using the latest WSDL version is most useful for reporting use cases. For integration purposes, specify the WSDL version to ensure consistent query behavior, that is, what is supported and included in the response returned by the API. **Note**: As of API version 69 and later, Zuora changed the format of certain fields. See Date Field Changes in the SOAP API for more information and a list of affected fields.
- `batchId` (string, optional) — A 32-character ID of the query batch.
- `batchType` (enum, optional) — The kind of batch job being submitted.
  - Allowed values: `zoql`, `zoqlexport`
- `deleted` (list of BatchesQueriesDeletedItems, optional) — This field indicates that the AQuA incremental load will retrieve deleted records. **Note**: AQuA API is subject to Zuora Data Retention Policy. The retention period of deleted data is 30 days. You can only retrieve deleted data for 30 days through AQuA.
- `full` (boolean, optional) — This field indicates a full or incremental load. `True` = Full and `False` = Incremental.
- `name` (string, optional) — Name of the query supplied in the request.
- `query` (string, optional) — The requested query string.
- `recordCount` (string, optional) — The number of records included in the query output file.
- `status` (enum, optional) — The status of the query task: - submitted: The query was submitted to the query executor for processing. - pending: The query was waiting for being processed. - executing: The query is being processed. - completed: The query was successfully executed. - aborted: The query execution failed. - deleted_notallowed: The query execution failed because objects included in the query do not support the querying of deleted records.
  - Allowed values: `submitted`, `pending`, `executing`, `completed`, `aborted`, `deleted_notallowed`

### BatchQueryDeletedItems

- `column` (string, optional) — Name of the Column in the extracted file that points to the deleted records.
- `format` (string, optional) — Can be set to either `Numeric` or `Boolean`. If set to `Numeric`, deleted records are marked as `1`. If set to `Boolean`, deleted records are marked as `true`.

### BatchesQueriesDeletedItems

- `column` (string, optional) — Name of the Column in the extracted file that points to the deleted records.
- `format` (string, optional) — Can be set to either `Numeric` or `Boolean`. If set to `Numeric`, deleted records are marked as `1`. If set to `Boolean`, deleted records are marked as `true`.

## Examples

**Request**

```json
{
  "queries": [
    {
      "query": "select AccountNumber, BillCycleDay from Account",
      "type": "zoql"
    }
  ]
}
```

**Response**

```json
{
  "batches": [
    {
      "apiVersion": "145.0",
      "batchId": "8ad08f06909293cd01909613f23549e5",
      "batchType": "zoql",
      "full": true,
      "query": "select AccountNumber, BillCycleDay from Account",
      "recordCount": "0",
      "status": "pending",
      "localizedStatus": "pending"
    }
  ],
  "encrypted": "none",
  "format": "csv",
  "id": "8ad08f06909293cd01909613f23549e4",
  "offset": 0,
  "status": "submitted",
  "useLastCompletedJobQueries": false,
  "version": 1
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/batch-query"

payload = { "queries": [
        {
            "query": "select AccountNumber, BillCycleDay from Account",
            "type": "zoql"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/batch-query';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"queries":[{"query":"select AccountNumber, BillCycleDay from Account","type":"zoql"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/batch-query"

	payload := strings.NewReader("{\n  \"queries\": [\n    {\n      \"query\": \"select AccountNumber, BillCycleDay from Account\",\n      \"type\": \"zoql\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/batch-query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"queries\": [\n    {\n      \"query\": \"select AccountNumber, BillCycleDay from Account\",\n      \"type\": \"zoql\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/batch-query")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"queries\": [\n    {\n      \"query\": \"select AccountNumber, BillCycleDay from Account\",\n      \"type\": \"zoql\"\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/batch-query', [
  'body' => '{
  "queries": [
    {
      "query": "select AccountNumber, BillCycleDay from Account",
      "type": "zoql"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/batch-query");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"queries\": [\n    {\n      \"query\": \"select AccountNumber, BillCycleDay from Account\",\n      \"type\": \"zoql\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["queries": [
    [
      "query": "select AccountNumber, BillCycleDay from Account",
      "type": "zoql"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/batch-query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```